package wanijo.wanijo2.http.controller

import org.commonmark.parser.Parser
import org.commonmark.renderer.html.HtmlRenderer
import org.springframework.stereotype.Controller
import org.springframework.ui.Model
import org.springframework.ui.set
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PathVariable
import wanijo.wanijo2.domain.DocumentDao
import wanijo.wanijo2.domain.TagDao
import wanijo.wanijo2.http.DocumentNotFound

@Controller
class ShowController(
    val docDao: DocumentDao,
    val tagDao: TagDao
) {

    @GetMapping("/document/{id}")
    fun show(
        model: Model,
        @PathVariable id: Long
    ): String {
        val document = docDao.findById(id) ?: throw DocumentNotFound()
        model["document"] = document

        model["tags"] = tagDao.ofDocument(id)

        val descHtml = Parser.builder().build().parse(document.description).let {
            HtmlRenderer.builder().build().render(it)
        }
        model["descHtml"] = descHtml

        return "show"
    }

}
